%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Summer School StrongMAR - 2016
% Array Data Processing
% Paulo Santos 
% 29th June, 2016
% DOA estimation
%
% Experimental Data - Makai 2005
% pjsantos@ualg.pt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%SOURCE TB2, data acquired on JD264 (September 20th) by a 4-element VSA 

clear all
%close all

% Sensors
L=4;
d=.1;
l=1:L;
r(l)=[-(l-1)*d];
rn=[zeros(2,L);r]; %z axis

% Data Time = 0.5s for each minute, 22 samples
minutoTB2=[27 63];

for m=1:length(minutoTB2)
  min=minutoTB2(m)
  matfile=['r2preprocTB2_min',num2str(min)]
  load(matfile);

  %%% Low frequency (assumed ship's noise)
 
  %indf=find(f>180 & f<190);
  indf=find(f>300 & f<310);
  %indf=find(f>720 & f<730);
  
  w=2*pi*f(indf);
  c=1530;

  K=-1;
  R=zeros(16,16);
  for n=1:length(p1(1025,:))
     V1= [K.*p1(indf,n); vx1(indf,n); vy1(indf,n); vz1(indf,n)]; % elemento 1
     V2= [K.*p2(indf,n); vx2(indf,n); vy2(indf,n); vz2(indf,n)]; % elemento 2
     V3= [K.*p3(indf,n); vx3(indf,n); vy3(indf,n); vz3(indf,n)]; % elemento 3
     V4= [K.*p1(indf,n); vx4(indf,n); vy4(indf,n); vz4(indf,n)]; % elemento 4
     V=[V1;V2;V3;V4];
     R=V*V'+R;
     %pause 
  end   
     Rs=1/length(p1(1025,:))*R;
     %pause
    
    tetha=0:360;
    phi=-90:90;
     
    for a_s=1:length(tetha)
      for e_s=1:length(phi)
        %sinal de busca "steer"
        %azi(a_s)=a_s-1;
        %elev(e_s)=e_s-1;
        tetha_s=(a_s)*pi/180;
        phi_s=(e_s)*pi/180;
        u_s=(-1).*[cos(tetha_s)*sin(phi_s) sin(tetha_s)*sin(phi_s) cos(phi_s)]; %vector director 
        k_s=w/c*u_s;
        tau_s=k_s*rn;
        wn=[1 cos(tetha_s)*sin(phi_s) sin(tetha_s)*sin(phi_s) cos(phi_s)];
        Xss=exp(j*tau_s); %atrasos simulados 
        Wn=[wn.*Xss(1) wn.*Xss(2) wn.*Xss(3) wn.*Xss(4)];
        
        B(a_s,e_s)=abs(Wn*Rs*Wn'); 

      end
    end
    
  disp('---------------')
  minuto=min
  [bmaxe binde]=(max(max(B)));
  [bmaxa binda]=(max(max(B')));
  Bnorm=B./bmaxe;
  azimute=binda-1;
  elevacao=binde-1;
   
  figure
  pcolor(tetha,phi,Bnorm')
  shading interp
  xh=xlabel('azimuth ( \circ)','fontsize',12);
  yh=ylabel('elevation ( \circ)','fontsize',12);
  title(['TB2 - Minuto ',num2str(min),'   f = ',num2str(f(indf)),' Hz'],'fontsize',12)
  set(gca,'fontsize',12)
  colorbar

  
  %pause
end  