
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Summer School StrongMAR - 2016
% Time and Frequency Modelling
% Paulo Santos 
% 29th June, 2016
% Show Impulse response
% pjsantos@ualg.pt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load('../sample_data/TAOex')
%%%%
% TAOex.mat matfile (OAEx data sample, Ilha dos porcos, see presentation for setup) 
% s tranmitted signal
% ddatalfm received signal (2 hydrophones)
% fs  sampling frequency
% fmin,fmax  band of the transmitted signal
%
%%%%%%%%%%%%%

[nsamp, nchan]=size(ddatalfm);

tt=(0:nsamp-1)/fs;

nsamps=length(s);
tts=(0:nsamps-1)/fs;
figure
subplot(211)
plot(tts*1000,s)
title('Transmitted Signal')
xlabel('Time(ms)')
subplot(212)
specgram(s,512,fs)
xlabel('Time(s)')
pause

figure
subplot(211)
plot(tt,ddatalfm(:,1))
xlabel('Time(s)')
title('Received Signal - Hydrophone 10m')
subplot(212)
plot(tt,ddatalfm(:,2))
xlabel('Time(s)')
title('Received signal - Hydrophone 20m')
pause

figure
subplot(211)
specgram(ddatalfm(:,1),512,fs) % spectrogram
xlabel('Time(s)')
title('Hydrophone 10m')
subplot(212)
specgram(ddatalfm(:,2),512,fs) % spectrogram
xlabel('Time(s)')
title('Hydrophone 20m')

%correlation
xs1=filter(s(end:-1:1),1,ddatalfm(:,1)); %%%correlation
%envelope (arrival pattern)
exs1=abs(hilbert(xs1));

xs2=filter(s(end:-1:1),1,ddatalfm(:,2));
exs2=abs(hilbert(xs2));

pause
figure
subplot(211)
plot(tt,xs1,'b')
xlabel('Time(s)')
title('Cross-correlation - Hydrophone 10m')

subplot(212)
plot(tt,xs2,'b')
xlabel('Time(s)')
title('Cross-correlation - Hydrophone 20m')

pause
figure
subplot(211)
plot(tt,exs1,'r')
xlabel('Time(s)')
title('Arrival pattern - Hydrophone 10m')

subplot(212)
plot(tt,exs2,'r')
xlabel('Time(s)')
title('Arrival pattern - Hydrophone 20m')
pause

figure
hold
plot(tt,exs1/max(exs1),'b', 'LineWidth',2)
plot(tt,exs2/max(exs2),'-.r', 'LineWidth',2)
set(gca,'Xlim',[0.14 0.17])
legend('Hydrophone 10m', 'Hydrophone 20m')
title('Zoom of arrival pattern')
xlabel('Time(s)')

