%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Summer School StrongMAR - 2016
% Time and Frequency Modelling
% Paulo Santos 
% 29th June, 2016
%
% C-TRACEO  Arrival patterns
% pjsantos@ualg.pt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%run ctraceo 
%amplitude arrival struct

load('aad') %

narr=arrivals.nArrivals

theta=[arrivals.arrival(1:narr).theta];
r=[arrivals.arrival(1:narr).r];
z=[arrivals.arrival(1:narr).z];
amp=[arrivals.arrival(1:narr).amp];
tau=[arrivals.arrival(1:narr).tau];

%[dummy ind]=find(abs(z-arrivals.zHyd)<0.01);


% figure
% subplot(211)
% stem(tau,real(amp))
% %hold
% %stem(tau(ind),real(amp(ind)),'r')
% xlabel('travel time (s)')
% ylabel('amplitude')
% 
% subplot(212)
% stem(tau,theta*180/pi)
% %hold
% %stem(tau(ind),theta(ind)*180/pi,'r')
% xlabel('travel time (s)')
% ylabel('angle ()')
% %

%signal block
fs=10000; %sampling frequency

%low frequecy lfm
fminL=400;
fmaxL=800;
lfmTL=3
t1s=0:1/fs:(lfmTL-1/fs);
idlelfmTL=0.25
tidle=0:1/fs:(idlelfmTL-1/fs);
slflfm=chirp(t1s,fminL,lfmTL,fmaxL);
NFFTlf=2*length(slflfm);
Slf=fft(slflfm,NFFTlf);
Slf2=Slf.*conj(Slf);


%high frequency lfm
fminH=1500
fmaxH=3500
lfmTH=3
t1s=0:1/fs:(lfmTH-1/fs);
idlelfmTH=0.25
tidle=0:1/fs:(idlelfmTH-1/fs);
shflfm=chirp(t1s,fminH,lfmTH,fmaxH);
NFFThf=2*length(shflfm);

Shf=fft(shflfm,NFFThf);
Shf2=Shf.*conj(Shf);

shLF=zeros(1,NFFTlf);
shHF=zeros(1,NFFThf);

%narr=narrmat(m,j);
Hlf=zeros(size(Slf));
Hhf=zeros(size(Shf));

%amp1=amp(ind);
%del1=tau(ind);
amp1=amp;
del1=tau;
for l=1:narr
    
    %low frequecy
    for k=1:fix(NFFTlf/2)
        w0=2*pi*(k-1)*fs/NFFTlf;
        Hlf(k)=Hlf(k)+amp1(l).*Slf2(k).*exp(-sqrt(-1)*w0*del1(l));
	%Hhf(k)=Hhf(k)+amp1(l).*Shf2(k).*exp(-sqrt(-1)*w0*del1(l));
    end
    
    %high frequecy
    for k=1:fix(NFFThf/2)
        w0=2*pi*(k-1)*fs/NFFThf;
       % Hlf(k)=Hlf(k)+amp1(l).*Slf2(k).*exp(-sqrt(-1)*w0*del1(l));
	Hhf(k)=Hhf(k)+amp1(l).*Shf2(k).*exp(-sqrt(-1)*w0*del1(l));
    end
end
H2xlf=[Hlf(1:NFFTlf/2) conj(Hlf(NFFTlf:-1:NFFTlf/2+1))];
shLF(:)=abs(hilbert(real(ifft(H2xlf))));
H2xhf=[Hhf(1:NFFThf/2) conj(Hhf(NFFThf:-1:NFFThf/2+1))];
shHF(:)=abs(hilbert(real(ifft(H2xhf))));
%Hx=ifft(H,NFFT);
%hx(j,m,:)=abs(Hx);
%hx=hx/max(hx)

nsamp=length(shHF);
time=(0:nsamp-1)/fs;
ind=find(shHF>5);
figure
plot(time(ind(1):ind(end)),shHF(ind(1):ind(end)),'b');
%grid on, box on
xlabel('Travel time (s)')
ylabel('Amplitude')
title('Arrival Pattern with CTRACEO')
